package org.cs3.dokuwiki.jsp.client;

/*
 * Defines a Javascript-JSPWiki to DokuWiki converter using and
 * adapting  the original JSP code and transforming it to 
 * Javascript using GWT
 * 
 * @author Pascal Bihler, bihler@iai.uni-bonn.de
 * 
 */

import org.cs3.dokuwiki.jsp.client.jspparser.JSPWikiMarkupParser;
import org.cs3.dokuwiki.jsp.client.jspparser.Reader;
import org.cs3.dokuwiki.jsp.client.output.DokuWikiOutput;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ChangeListener;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.KeyboardListener;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextArea;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.xml.client.Document;

public class JspConverter implements EntryPoint {

	public JspConverter() {
	}

	public void onModuleLoad() {
	    final Button button = new Button("Convert to DokuWiki source");
	    button.setEnabled(false);
	    button.setStyleName("button");
	    final TextArea ta = new TextArea();
	    ta.setStyleName("edit");
	    ta.setCharacterWidth(80);
	    ta.setVisibleLines(20);
	    ta.addKeyboardListener(new KeyboardListener() {

			public void onKeyDown(Widget arg0, char arg1, int arg2) {}

			public void onKeyPress(Widget arg0, char arg1, int arg2) {}

			public void onKeyUp(Widget arg0, char arg1, int arg2) {
				button.setEnabled(! "".equals(ta.getText()));
			}});
	    ta.addChangeListener(new ChangeListener() { // unfortunately doesn't work always...
			public void onChange(Widget arg0) {
				button.setEnabled(! "".equals(ta.getText()));				
			}});

	    final Label comment = new Label();
	    
	    
	    button.addClickListener(new ClickListener() {
		      public void onClick(Widget sender) {
		    	   	  comment.setText("Please stand by while processing... (This may take a while)");
			    	  JSPWikiMarkupParser parser = new JSPWikiMarkupParser(new Reader(ta.getText()));
			    	  
			    	  Document doc = parser.parse();
			    	  addText(new DokuWikiOutput(doc).dump());
		      }
		    });

		RootPanel.get("textarea").add(ta);
		RootPanel.get("control").add(button);
		RootPanel.get("control").add(comment);

	}
	
	/**
	 * Add the text to the parent window
	 * @param text
	 */
    public static native void addText(String text) /*-{
    	$wnd.parent.window.opener.addTextFromJspWiki(text);
	    $wnd.close();
    }-*/;

}
