package org.cs3.dokuwiki.jsp.client.apache.oro.text.regex;

/*
 * Copy of parts of java.lang.Character for GWT compatibility
 * 
 */
public class CharacterHelper {

	  /**
     * The minimum radix available for conversion to and from strings.
     * The constant value of this field is the smallest value permitted
     * for the radix argument in radix-conversion methods such as the
     * <code>digit</code> method, the <code>forDigit</code>
     * method, and the <code>toString</code> method of class
     * <code>Integer</code>.
     *
     * @see     java.lang.Character#digit(char, int)
     * @see     java.lang.Character#forDigit(int, int)
     * @see     java.lang.Integer#toString(int, int)
     * @see     java.lang.Integer#valueOf(java.lang.String)
     */
    public static final int MIN_RADIX = 2;

    /**
     * The maximum radix available for conversion to and from strings.
     * The constant value of this field is the largest value permitted
     * for the radix argument in radix-conversion methods such as the
     * <code>digit</code> method, the <code>forDigit</code>
     * method, and the <code>toString</code> method of class
     * <code>Integer</code>.
     *
     * @see     java.lang.Character#digit(char, int)
     * @see     java.lang.Character#forDigit(int, int)
     * @see     java.lang.Integer#toString(int, int)
     * @see     java.lang.Integer#valueOf(java.lang.String)
     */
    public static final int MAX_RADIX = 36;

    /**
     * The constant value of this field is the smallest value of type
     * <code>char</code>, <code>'&#92;u0000'</code>.
     *
     * @since   1.0.2
     */
    public static final char   MIN_VALUE = '\u0000';

    /**
     * The constant value of this field is the largest value of type
     * <code>char</code>, <code>'&#92;uFFFF'</code>.
     *
     * @since   1.0.2
     */
    public static final char   MAX_VALUE = '\uffff';
    
	/**
	    * General category "Cn" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        UNASSIGNED                  = 0;

	   /**
	    * General category "Lu" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        UPPERCASE_LETTER            = 1;

	   /**
	    * General category "Ll" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        LOWERCASE_LETTER            = 2;

	   /**
	    * General category "Lt" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        TITLECASE_LETTER            = 3;

	   /**
	    * General category "Lm" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        MODIFIER_LETTER             = 4;

	   /**
	    * General category "Lo" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        OTHER_LETTER                = 5;

	   /**
	    * General category "Mn" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        NON_SPACING_MARK            = 6;

	   /**
	    * General category "Me" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        ENCLOSING_MARK              = 7;

	   /**
	    * General category "Mc" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        COMBINING_SPACING_MARK      = 8;

	   /**
	    * General category "Nd" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        DECIMAL_DIGIT_NUMBER        = 9;

	   /**
	    * General category "Nl" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        LETTER_NUMBER               = 10;

	   /**
	    * General category "No" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        OTHER_NUMBER                = 11;

	   /**
	    * General category "Zs" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        SPACE_SEPARATOR             = 12;

	   /**
	    * General category "Zl" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        LINE_SEPARATOR              = 13;

	   /**
	    * General category "Zp" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        PARAGRAPH_SEPARATOR         = 14;

	   /**
	    * General category "Cc" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        CONTROL                     = 15;

	   /**
	    * General category "Cf" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        FORMAT                      = 16;

	   /**
	    * General category "Co" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        PRIVATE_USE                 = 18;

	   /**
	    * General category "Cs" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        SURROGATE                   = 19;

	   /**
	    * General category "Pd" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        DASH_PUNCTUATION            = 20;

	   /**
	    * General category "Ps" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        START_PUNCTUATION           = 21;

	   /**
	    * General category "Pe" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        END_PUNCTUATION             = 22;

	   /**
	    * General category "Pc" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        CONNECTOR_PUNCTUATION       = 23;

	   /**
	    * General category "Po" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        OTHER_PUNCTUATION           = 24;

	   /**
	    * General category "Sm" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        MATH_SYMBOL                 = 25;

	   /**
	    * General category "Sc" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        CURRENCY_SYMBOL             = 26;

	   /**
	    * General category "Sk" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        MODIFIER_SYMBOL             = 27;

	   /**
	    * General category "So" in the Unicode specification.
	    * @since   1.1
	    */
	    public static final byte
	        OTHER_SYMBOL                = 28;

	   /**
	    * General category "Pi" in the Unicode specification.
	    * @since   1.4
	    */
	    public static final byte
	        INITIAL_QUOTE_PUNCTUATION   = 29;

	   /**
	    * General category "Pf" in the Unicode specification.
	    * @since   1.4
	    */
	    public static final byte
	        FINAL_QUOTE_PUNCTUATION     = 30;

	    /**
	     * Error flag. Use int (code point) to avoid confusion with U+FFFF.
	     */
	     static final int ERROR = 0xFFFFFFFF;


	    /**
	     * Undefined bidirectional character type. Undefined <code>char</code>
	     * values have undefined directionality in the Unicode specification.
	     * @since 1.4
	     */
	     public static final byte DIRECTIONALITY_UNDEFINED = -1;

	    /**
	     * Strong bidirectional character type "L" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_LEFT_TO_RIGHT = 0;

	    /**
	     * Strong bidirectional character type "R" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_RIGHT_TO_LEFT = 1;

	    /**
	    * Strong bidirectional character type "AL" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_RIGHT_TO_LEFT_ARABIC = 2;

	    /**
	     * Weak bidirectional character type "EN" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_EUROPEAN_NUMBER = 3;

	    /**
	     * Weak bidirectional character type "ES" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_EUROPEAN_NUMBER_SEPARATOR = 4;

	    /**
	     * Weak bidirectional character type "ET" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_EUROPEAN_NUMBER_TERMINATOR = 5;

	    /**
	     * Weak bidirectional character type "AN" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_ARABIC_NUMBER = 6;

	    /**
	     * Weak bidirectional character type "CS" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_COMMON_NUMBER_SEPARATOR = 7;

	    /**
	     * Weak bidirectional character type "NSM" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_NONSPACING_MARK = 8;

	    /**
	     * Weak bidirectional character type "BN" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_BOUNDARY_NEUTRAL = 9;

	    /**
	     * Neutral bidirectional character type "B" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_PARAGRAPH_SEPARATOR = 10;

	    /**
	     * Neutral bidirectional character type "S" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_SEGMENT_SEPARATOR = 11;

	    /**
	     * Neutral bidirectional character type "WS" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_WHITESPACE = 12;

	    /**
	     * Neutral bidirectional character type "ON" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_OTHER_NEUTRALS = 13;

	    /**
	     * Strong bidirectional character type "LRE" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_LEFT_TO_RIGHT_EMBEDDING = 14;

	    /**
	     * Strong bidirectional character type "LRO" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_LEFT_TO_RIGHT_OVERRIDE = 15;

	    /**
	     * Strong bidirectional character type "RLE" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_RIGHT_TO_LEFT_EMBEDDING = 16;

	    /**
	     * Strong bidirectional character type "RLO" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_RIGHT_TO_LEFT_OVERRIDE = 17;

	    /**
	     * Weak bidirectional character type "PDF" in the Unicode specification.
	     * @since 1.4
	     */
	    public static final byte DIRECTIONALITY_POP_DIRECTIONAL_FORMAT = 18;

	    /**
	     * The minimum value of a Unicode high-surrogate code unit in the
	     * UTF-16 encoding. A high-surrogate is also known as a
	     * <i>leading-surrogate</i>.
	     *
	     * @since 1.5
	     */
	    public static final char MIN_HIGH_SURROGATE = '\uD800';

	    /**
	     * The maximum value of a Unicode high-surrogate code unit in the
	     * UTF-16 encoding. A high-surrogate is also known as a
	     * <i>leading-surrogate</i>.
	     *
	     * @since 1.5
	     */
	    public static final char MAX_HIGH_SURROGATE = '\uDBFF';

	    /**
	     * The minimum value of a Unicode low-surrogate code unit in the
	     * UTF-16 encoding. A low-surrogate is also known as a
	     * <i>trailing-surrogate</i>.
	     *
	     * @since 1.5
	     */
	    public static final char MIN_LOW_SURROGATE  = '\uDC00';

	    /**
	     * The maximum value of a Unicode low-surrogate code unit in the
	     * UTF-16 encoding. A low-surrogate is also known as a
	     * <i>trailing-surrogate</i>.
	     *
	     * @since 1.5
	     */
	    public static final char MAX_LOW_SURROGATE  = '\uDFFF';

	    /**
	     * The minimum value of a Unicode surrogate code unit in the UTF-16 encoding.
	     *
	     * @since 1.5
	     */
	    public static final char MIN_SURROGATE = MIN_HIGH_SURROGATE;

	    /**
	     * The maximum value of a Unicode surrogate code unit in the UTF-16 encoding.
	     *
	     * @since 1.5
	     */
	    public static final char MAX_SURROGATE = MAX_LOW_SURROGATE;

	    /**
	     * The minimum value of a supplementary code point.
	     *
	     * @since 1.5
	     */
	    public static final int MIN_SUPPLEMENTARY_CODE_POINT = 0x010000;

	    /**
	     * The minimum value of a Unicode code point.
	     * 
	     * @since 1.5
	     */
	    public static final int MIN_CODE_POINT = 0x000000;

	    /**
	     * The maximum value of a Unicode code point.
	     *
	     * @since 1.5
	     */
	    public static final int MAX_CODE_POINT = 0x10ffff;
     
    private static final int FAST_PATH_MAX = 255;
    
	 /**
     * Determines if the specified character is white space according to Java.
     * A character is a Java whitespace character if and only if it satisfies
     * one of the following criteria:
     * <ul>
     * <li> It is a Unicode space character (<code>SPACE_SEPARATOR</code>,
     *      <code>LINE_SEPARATOR</code>, or <code>PARAGRAPH_SEPARATOR</code>) 
     *      but is not also a non-breaking space (<code>'&#92;u00A0'</code>,
     *      <code>'&#92;u2007'</code>, <code>'&#92;u202F'</code>).
     * <li> It is <code>'&#92;u0009'</code>, HORIZONTAL TABULATION.
     * <li> It is <code>'&#92;u000A'</code>, LINE FEED.
     * <li> It is <code>'&#92;u000B'</code>, VERTICAL TABULATION.
     * <li> It is <code>'&#92;u000C'</code>, FORM FEED.
     * <li> It is <code>'&#92;u000D'</code>, CARRIAGE RETURN.
     * <li> It is <code>'&#92;u001C'</code>, FILE SEPARATOR.
     * <li> It is <code>'&#92;u001D'</code>, GROUP SEPARATOR.
     * <li> It is <code>'&#92;u001E'</code>, RECORD SEPARATOR.
     * <li> It is <code>'&#92;u001F'</code>, UNIT SEPARATOR.
     * </ul>
     * </ul>
     * <b>This simplified implementation works just for Latin1 Characters!</b>
     * <p>
     *
     * <p><b>Note:</b> This method cannot handle <a
     * href="#supplementary"> supplementary characters</a>. To support
     * all Unicode characters, including supplementary characters, use
     * the {@link #isWhitespace(int)} method.
     *
     * @param   ch the character to be tested.
     * @return  <code>true</code> if the character is a Java whitespace
     *          character; <code>false</code> otherwise.
     * @see     java.lang.Character#isSpaceChar(char)
     * @since   1.1
     */
    public static boolean isWhitespace(char ch) {
        return isWhitespace((int)ch);
    }

    /**
     * Determines if the specified character (Unicode code point) is
     * white space according to Java.  A character is a Java
     * whitespace character if and only if it satisfies one of the
     * following criteria:
     * <ul>
     * <li> It is a Unicode space character ({@link #SPACE_SEPARATOR},
     *      {@link #LINE_SEPARATOR}, or {@link #PARAGRAPH_SEPARATOR}) 
     *      but is not also a non-breaking space (<code>'&#92;u00A0'</code>,
     *      <code>'&#92;u2007'</code>, <code>'&#92;u202F'</code>).
     * <li> It is <code>'&#92;u0009'</code>, HORIZONTAL TABULATION.
     * <li> It is <code>'&#92;u000A'</code>, LINE FEED.
     * <li> It is <code>'&#92;u000B'</code>, VERTICAL TABULATION.
     * <li> It is <code>'&#92;u000C'</code>, FORM FEED.
     * <li> It is <code>'&#92;u000D'</code>, CARRIAGE RETURN.
     * <li> It is <code>'&#92;u001C'</code>, FILE SEPARATOR.
     * <li> It is <code>'&#92;u001D'</code>, GROUP SEPARATOR.
     * <li> It is <code>'&#92;u001E'</code>, RECORD SEPARATOR.
     * <li> It is <code>'&#92;u001F'</code>, UNIT SEPARATOR.
     * </ul>
     * <b>This simplified implementation works just for Latin1 Characters!</b>
     * <p>
     *
     * @param   codePoint the character (Unicode code point) to be tested.
     * @return  <code>true</code> if the character is a Java whitespace
     *          character; <code>false</code> otherwise.
     * @see     java.lang.Character#isSpaceChar(int)
     * @since   1.5
     */
    public static boolean isWhitespace(int codePoint) {
        boolean bWhiteSpace = false;

        if (codePoint >= MIN_CODE_POINT && codePoint <= FAST_PATH_MAX) {
            bWhiteSpace =  CharacterDataLatin1Helper.isWhitespace(codePoint);
        } else {
            int plane = getPlane(codePoint);
            switch(plane) {
            case(0):
                bWhiteSpace = true;
                break;
            case(1):
                bWhiteSpace = true;
                break;
            case(2):
                bWhiteSpace = true;
                break;
            case(3): // Undefined
            case(4): // Undefined
            case(5): // Undefined
            case(6): // Undefined
            case(7): // Undefined
            case(8): // Undefined
            case(9): // Undefined
            case(10): // Undefined
            case(11): // Undefined
            case(12): // Undefined
            case(13): // Undefined
                bWhiteSpace = true;
                break;
            case(14): 
                bWhiteSpace = true;
                break;
            case(15): // Private Use
            case(16): // Private Use
                bWhiteSpace = true;
                break;
            default:
                // the argument's plane is invalid, and thus is an invalid codepoint
                // bWhiteSpace remains false
                break;
            }
        }
        return bWhiteSpace;
    }
    
    /**
     * Determines if the specified character is a Unicode space character.
     * A character is considered to be a space character if and only if
     * it is specified to be a space character by the Unicode standard. This
     * method returns true if the character's general category type is any of
     * the following:
     * <ul>
     * <li> <code>SPACE_SEPARATOR</code>
     * <li> <code>LINE_SEPARATOR</code>
     * <li> <code>PARAGRAPH_SEPARATOR</code>
     * </ul>
     * </ul>
     * <b>This simplified implementation works just for Latin1 Characters!</b>
     * <p>
     *
     * <p><b>Note:</b> This method cannot handle <a
     * href="#supplementary"> supplementary characters</a>. To support
     * all Unicode characters, including supplementary characters, use
     * the {@link #isSpaceChar(int)} method.
     *
     * @param   ch      the character to be tested.
     * @return  <code>true</code> if the character is a space character; 
     *          <code>false</code> otherwise.
     * @see     java.lang.Character#isWhitespace(char)
     * @since   1.1
     */
    public static boolean isSpaceChar(char ch) {
        return isSpaceChar((int)ch);
    }

    /**
     * Determines if the specified character (Unicode code point) is a
     * Unicode space character.  A character is considered to be a
     * space character if and only if it is specified to be a space
     * character by the Unicode standard. This method returns true if
     * the character's general category type is any of the following:
     *
     * <ul>
     * <li> {@link #SPACE_SEPARATOR}
     * <li> {@link #LINE_SEPARATOR}
     * <li> {@link #PARAGRAPH_SEPARATOR}
     * </ul>
     * </ul>
     * <b>This simplified implementation works just for Latin1 Characters!</b>
     * <p>
     *
     * @param   codePoint the character (Unicode code point) to be tested.
     * @return  <code>true</code> if the character is a space character; 
     *          <code>false</code> otherwise.
     * @see     java.lang.Character#isWhitespace(int)
     * @since   1.5
     */
    public static boolean isSpaceChar(int codePoint) {
        boolean bSpaceChar = false;

        if (codePoint >= MIN_CODE_POINT && codePoint <=  FAST_PATH_MAX) {
            bSpaceChar =  CharacterDataLatin1Helper.isSpaceChar(codePoint);
        } else {
            int plane = getPlane(codePoint);
            switch(plane) {
            case(0):
                bSpaceChar = false;
                break;
            case(1):
                bSpaceChar = false;
                break;
            case(2):
                bSpaceChar = false;
                break;
            case(3): // Undefined
            case(4): // Undefined
            case(5): // Undefined
            case(6): // Undefined
            case(7): // Undefined
            case(8): // Undefined
            case(9): // Undefined
            case(10): // Undefined
            case(11): // Undefined
            case(12): // Undefined
            case(13): // Undefined
                bSpaceChar = false;
                break;
            case(14): 
                bSpaceChar = false;
                break;
            case(15): // Private Use
            case(16): // Private Use
                bSpaceChar = false;
                break;
            default:
                // the argument's plane is invalid, and thus is an invalid codepoint
                // bSpaceChar remains false
                break;
            }
        }
        return bSpaceChar;
    }
    /**
     * Determines if the specified character is an ISO control
     * character.  A character is considered to be an ISO control
     * character if its code is in the range <code>'&#92;u0000'</code>
     * through <code>'&#92;u001F'</code> or in the range
     * <code>'&#92;u007F'</code> through <code>'&#92;u009F'</code>.
     *
     * <p><b>Note:</b> This method cannot handle <a
     * href="#supplementary"> supplementary characters</a>. To support
     * all Unicode characters, including supplementary characters, use
     * the {@link #isISOControl(int)} method.
     *
     * @param   ch      the character to be tested.
     * @return  <code>true</code> if the character is an ISO control character;
     *          <code>false</code> otherwise.
     *
     * @see     java.lang.Character#isSpaceChar(char)
     * @see     java.lang.Character#isWhitespace(char)
     * @since   1.1
     */
    public static boolean isISOControl(char ch) {
        return isISOControl((int)ch);
    }

    /**
     * Determines if the referenced character (Unicode code point) is an ISO control
     * character.  A character is considered to be an ISO control
     * character if its code is in the range <code>'&#92;u0000'</code>
     * through <code>'&#92;u001F'</code> or in the range
     * <code>'&#92;u007F'</code> through <code>'&#92;u009F'</code>.
     *
     * @param   codePoint the character (Unicode code point) to be tested.
     * @return  <code>true</code> if the character is an ISO control character;
     *          <code>false</code> otherwise.
     * @see     java.lang.Character#isSpaceChar(int)
     * @see     java.lang.Character#isWhitespace(int)
     * @since   1.5
     */
    public static boolean isISOControl(int codePoint) {
        return (codePoint >= 0x0000 && codePoint <= 0x001F) || 
            (codePoint >= 0x007F && codePoint <= 0x009F);
    }
    /**
     * Returns a value indicating a character's general category.
     *
     * <p><b>Note:</b> This method cannot handle <a
     * href="#supplementary"> supplementary characters</a>. To support
     * all Unicode characters, including supplementary characters, use
     * the {@link #getType(int)} method.
     * <b>This simplified implementation works just for Latin1 Characters!</b>
     * <p>
     *
     * @param   ch      the character to be tested.
     * @return  a value of type <code>int</code> representing the 
     *          character's general category.
     * @see     java.lang.Character#COMBINING_SPACING_MARK
     * @see     java.lang.Character#CONNECTOR_PUNCTUATION
     * @see     java.lang.Character#CONTROL
     * @see     java.lang.Character#CURRENCY_SYMBOL
     * @see     java.lang.Character#DASH_PUNCTUATION
     * @see     java.lang.Character#DECIMAL_DIGIT_NUMBER
     * @see     java.lang.Character#ENCLOSING_MARK
     * @see     java.lang.Character#END_PUNCTUATION
     * @see     java.lang.Character#FINAL_QUOTE_PUNCTUATION
     * @see     java.lang.Character#FORMAT
     * @see     java.lang.Character#INITIAL_QUOTE_PUNCTUATION
     * @see     java.lang.Character#LETTER_NUMBER
     * @see     java.lang.Character#LINE_SEPARATOR
     * @see     java.lang.Character#LOWERCASE_LETTER
     * @see     java.lang.Character#MATH_SYMBOL
     * @see     java.lang.Character#MODIFIER_LETTER
     * @see     java.lang.Character#MODIFIER_SYMBOL
     * @see     java.lang.Character#NON_SPACING_MARK
     * @see     java.lang.Character#OTHER_LETTER
     * @see     java.lang.Character#OTHER_NUMBER
     * @see     java.lang.Character#OTHER_PUNCTUATION
     * @see     java.lang.Character#OTHER_SYMBOL
     * @see     java.lang.Character#PARAGRAPH_SEPARATOR
     * @see     java.lang.Character#PRIVATE_USE
     * @see     java.lang.Character#SPACE_SEPARATOR
     * @see     java.lang.Character#START_PUNCTUATION
     * @see     java.lang.Character#SURROGATE
     * @see     java.lang.Character#TITLECASE_LETTER
     * @see     java.lang.Character#UNASSIGNED
     * @see     java.lang.Character#UPPERCASE_LETTER
     * @since   1.1
     */
    public static int getType(char ch) {
        return getType((int)ch);
    }

    /**
     * Returns a value indicating a character's general category.
     * <b>This simplified implementation works just for Latin1 Characters!</b>
     * <p>
     *
     * @param   codePoint the character (Unicode code point) to be tested.
     * @return  a value of type <code>int</code> representing the 
     *          character's general category.
     * @see     Character#COMBINING_SPACING_MARK COMBINING_SPACING_MARK
     * @see     Character#CONNECTOR_PUNCTUATION CONNECTOR_PUNCTUATION
     * @see     Character#CONTROL CONTROL
     * @see     Character#CURRENCY_SYMBOL CURRENCY_SYMBOL
     * @see     Character#DASH_PUNCTUATION DASH_PUNCTUATION
     * @see     Character#DECIMAL_DIGIT_NUMBER DECIMAL_DIGIT_NUMBER
     * @see     Character#ENCLOSING_MARK ENCLOSING_MARK
     * @see     Character#END_PUNCTUATION END_PUNCTUATION
     * @see     Character#FINAL_QUOTE_PUNCTUATION FINAL_QUOTE_PUNCTUATION
     * @see     Character#FORMAT FORMAT
     * @see     Character#INITIAL_QUOTE_PUNCTUATION INITIAL_QUOTE_PUNCTUATION
     * @see     Character#LETTER_NUMBER LETTER_NUMBER
     * @see     Character#LINE_SEPARATOR LINE_SEPARATOR
     * @see     Character#LOWERCASE_LETTER LOWERCASE_LETTER
     * @see     Character#MATH_SYMBOL MATH_SYMBOL
     * @see     Character#MODIFIER_LETTER MODIFIER_LETTER
     * @see     Character#MODIFIER_SYMBOL MODIFIER_SYMBOL
     * @see     Character#NON_SPACING_MARK NON_SPACING_MARK
     * @see     Character#OTHER_LETTER OTHER_LETTER
     * @see     Character#OTHER_NUMBER OTHER_NUMBER
     * @see     Character#OTHER_PUNCTUATION OTHER_PUNCTUATION
     * @see     Character#OTHER_SYMBOL OTHER_SYMBOL
     * @see     Character#PARAGRAPH_SEPARATOR PARAGRAPH_SEPARATOR
     * @see     Character#PRIVATE_USE PRIVATE_USE
     * @see     Character#SPACE_SEPARATOR SPACE_SEPARATOR
     * @see     Character#START_PUNCTUATION START_PUNCTUATION
     * @see     Character#SURROGATE SURROGATE
     * @see     Character#TITLECASE_LETTER TITLECASE_LETTER
     * @see     Character#UNASSIGNED UNASSIGNED
     * @see     Character#UPPERCASE_LETTER UPPERCASE_LETTER
     * @since   1.5
     */
    public static int getType(int codePoint) {
        int type = CharacterHelper.UNASSIGNED;

        if (codePoint >= MIN_CODE_POINT && codePoint <= FAST_PATH_MAX) {
            type = CharacterDataLatin1Helper.getType(codePoint);
        } else {
            int plane = getPlane(codePoint);
            switch(plane) {
            case(0):
                type = CharacterHelper.UNASSIGNED;
                break;
            case(1):
                type = CharacterHelper.UNASSIGNED;
                break;
            case(2):
                type = CharacterHelper.UNASSIGNED;
                break;
            case(3): // Undefined
            case(4): // Undefined
            case(5): // Undefined
            case(6): // Undefined
            case(7): // Undefined
            case(8): // Undefined
            case(9): // Undefined
            case(10): // Undefined
            case(11): // Undefined
            case(12): // Undefined
            case(13): // Undefined      
                type = CharacterHelper.UNASSIGNED;
                break;
            case(14): 
                type = CharacterHelper.UNASSIGNED;
                break;
            case(15): // Private Use
            case(16): // Private Use
                type = CharacterHelper.UNASSIGNED;
                break;
            default:
                // the argument's plane is invalid, and thus is an invalid codepoint
                // type remains UNASSIGNED
                break;
            }
        }
        return type;
    }
    
    private static int getPlane(int ch) {
        return (ch >>> 16);
    }
}
